﻿
Public Class TecRace

#Region "New"

    Public List As New List(Of String)
    Public Path As String = IO.Path.GetDirectoryName(Windows.Forms.Application.ExecutablePath)
    Public Random As New Random

    Public WithEvents Timer As New Timer

    Private Sub TecFrame_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Timer.Interval = 1
        Timer.Start()
    End Sub

    Private Sub NameLabel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NameLabel.Click

        System.Diagnostics.Process.Start(NameLabel.Text)
    End Sub

#End Region

#Region "Tool"

    Public Sub DoSleep(Optional ByVal Time As Double = 1)

        If (Time = 0) Then
            System.Windows.Forms.Application.DoEvents()
            Return
        End If

        Dim DateTime As Date = Now
        Time = Math.Max(1, Time * 1000 * 10 * 1000)

        While Now.Subtract(DateTime).Ticks < Time

            System.Windows.Forms.Application.DoEvents()
            System.Threading.Thread.Sleep(10)
        End While
    End Sub

#End Region

#Region "Action"
 
    Private Sub Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer.Tick

        Timer.Stop()

        Dim Work() As String = IO.Directory.GetDirectories(Path)
        If Me.List.Count = 0 Then
            For Each pt As String In Work
                If IO.Directory.GetFiles(pt, "*.png").Count <> 0 Then
                    Me.List.Add(pt)
                End If
            Next
        End If

        Dim no As Integer = Random.Next(Me.List.Count)
        Dim Name As String = IO.Path.GetFileNameWithoutExtension(Me.List(no))
        Me.List.RemoveAt(no)

        Work = IO.Directory.GetFiles(Path & "\" & Name, "*.png")
        Dim List As New List(Of String)
        Dim Item As New List(Of cItem)

        For ct As Integer = 0 To 5 - 1
            If List.Count = 0 Then
                For Each pt As String In Work
                    List.Add(pt)
                Next
            End If

            no = Random.Next(List.Count)
            Dim Image As Bitmap = New Bitmap(List(no))
            Image.MakeTransparent(Image.GetPixel(0, 0))
            Dim Line() As String = Split(List(no), "_")
            ReDim Preserve Line(1)
            Image.Tag = IO.Path.GetFileNameWithoutExtension(Line(1))

            Item.Add(New cItem(Image, 0.15, -0.9, -(ct - 2) * 0.32))
            List.RemoveAt(no)
        Next

        Dim Bitmap As Bitmap = New Bitmap(10, 10)

        Dim Pos As Double = -1
        For Mode As Integer = 0 To 2

            Dim Number As Integer
            Select Case Mode
                Case 0 : Number = 50
                Case 1 : Number = 200
                Case 2 : Number = 50
            End Select

            For Count As Integer = 0 To Number - 1

                If (Bitmap.Width <> PictureBox.Width) Or (Bitmap.Height <> PictureBox.Height) Then
                    PictureBox.Image = Nothing
                    Bitmap.Dispose()
                    Bitmap = New Bitmap(PictureBox.Width, PictureBox.Height)
                End If

                Dim Time As Double = (Count / Number) * 10
                StatusLabel.Text = Name & ":" & Format(Time, "0")

                If Mode = 1 Then
                    For Each pt As cItem In Item
                        pt.Pos += Random.NextDouble / 50
                        Pos = Math.Max(Pos, pt.Pos)
                    Next
                    For Each pt As cItem In Item
                        Time = (Count / Number) * 1.8 - 0.9

                        pt.PosX = Time - (Pos - pt.Pos)
                    Next
                End If
                Using g As Graphics = Graphics.FromImage(Bitmap)
                    g.FillRectangle(SystemBrushes.Control, New Rectangle(0, 0, Bitmap.Width, Bitmap.Height))

                    For Each pt As cItem In Item
                        pt.Draw(g, Bitmap, Pos = pt.Pos)

                        If (Pos = pt.Pos) Then
                            StatusLabel.Text = Name & ":" & pt.Image.Tag
                        End If
                    Next
                End Using

                PictureBox.Image = Bitmap
                DoSleep(0.1)
            Next
        Next

        For Each pt As cItem In Item
            pt.Image.Dispose()
        Next
        Bitmap.Dispose()
        Timer.Start()
    End Sub

#End Region

#Region "cItem"

    Public Class cItem

#Region "New"

        Public Image As Bitmap
        Public Size As Double
        Public PosX As Double
        Public PosY As Double
        Public Angle As Double

        Public Pos As Double

        Public Sub New(ByVal Image As Bitmap, ByVal Size As Double, ByVal PosX As Double, ByVal PosY As Double)

            Me.Image = Image
            Me.Size = Size
            Me.PosX = PosX
            Me.PosY = PosY
        End Sub

#End Region

#Region "Draw"

        Public Sub Draw(ByVal g As Graphics, ByVal Bitmap As Bitmap, ByVal Flag As Boolean)

            Dim SizeB As Integer = Math.Min(Bitmap.Width, Bitmap.Height)
            Dim SizeI As Integer = Math.Min(Image.Width, Image.Height)
            Dim SizeX As Integer = SizeB * Size * (Image.Width / SizeI)
            Dim SizeY As Integer = SizeB * Size * (Image.Height / SizeI)
            Dim PosX As Integer = Me.PosX * (Bitmap.Width / 2) + Bitmap.Width / 2
            Dim PosY As Integer = -Me.PosY * (Bitmap.Height / 2) + Bitmap.Height / 2

            g.DrawImage(Image, New RectangleF(PosX - SizeX / 2, PosY - SizeY / 2, SizeX, SizeY), New RectangleF(0, 0, Image.Width, Image.Height), GraphicsUnit.Pixel)

            If Flag Then
                Using Pen As New Pen(Color.Red, 3)
                    g.DrawEllipse(Pen, New RectangleF(PosX - SizeX / 2, PosY - SizeY / 2, SizeX, SizeY))
                End Using
            End If

        End Sub

#End Region

    End Class

#End Region

End Class